classification
Title: Deprecate bdist_wininst: use bdist_wheel instead
Type: Stage: resolved
Components: Distutils, Windows Versions: Python 3.9, Python 3.8
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: Nosy List: dstufft, eric.araujo, miss-islington, p-ganssle, paul.moore, steve.dower, tim.golden, vstinner, zach.ware
Priority: normal Keywords: patch

Created on 2019-07-02 11:05 by vstinner, last changed 2019-07-05 10:26 by vstinner. This issue is now closed.

Pull Requests
URL Status Linked Edit
PR 14553 merged vstinner, 2019-07-02 11:19
PR 14598 merged miss-islington, 2019-07-05 08:44
Messages (6)
msg347131 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-07-02 11:05
According to the following "Deprecate bdist_wininst" discussion, bdist_wininst can be deprecated:
https://discuss.python.org/t/deprecate-bdist-wininst/1929

bdist_wininst uses the mbcs encoding which is only available on Windows. There is bpo-10945 open for 8 years to suggest to use UTF-8 or use the Unicode (wide character) flavor of the Windows API to support running bdist_wininst on non-Windows platforms and to be able to distribute binaries which don’t depend on the ANSI code page.

I propose to deprecate it in Python 3.9, because of bpo-10945 issue. I don't propose to plan bdist_wininst removal yet.

As an user, it’s annoying to have to run a GUI to install something, whereas pip can install dependencies using wheel packages in a command line interface, transparently, without bugging the user with dialog boxes.

When I look at numpy or Cython: they don’t distribute .exe installers, but binary wheel packages for Windows. I understood the wheel packages is the recommended way to distribute binaries on Windows, and so that bdist_wininst is kind of deprecated.

Donald Stufft wrote:

"For what it’s worth, PyPI doesn’t even allow you to upload bdist_wininst (See PEP 527 2) anymore, so if you’re looking at PyPI to determine usage, you’re going to get no usage whatsoever for anything recent.

I don’t have any idea if other people are still using bdist_wininst and distributing them through some other mechanism."

Paul Ganssle wrote:

"From my perspective, nearly all direct invocations of setup.py are currently or are eventually heading for deprecation. PEP 517 doesn’t provide hooks to generate anything other than sdist or wheel, so basically all commands not actually triggered (directly or indirectly) by calling a PEP 517 front-end are suspect."


Attached PR deprecates bdist_wininst.


See also the related issue bpo-37468 "Don't install wininst*.exe on non-Windows platforms". bdist_wininst only works on Windows: see bpo-10945 and commit 72cd653c4ed7a4f8f8fb06ac364b08a97085a2b5.
msg347153 - (view) Author: Steve Dower (steve.dower) * (Python committer) Date: 2019-07-02 20:06
For the record, I am 100% in favor of deprecating and removing bdist_wininst and bdist_msi from distutils as soon as possible, as they are maintenance burdens and bdist_wininst in particular often attracts AV false positives.

setuptools is welcome to either do the same or restore the functionality, I don't have any preference if someone else is maintaining it (but I'd suggest removal there too until someone wants to maintain it).

Some of our distributions of Python already exclude bdist_wininst, so it can't be blindly relied on. And I don't know that it was ever upgraded for PEP 514. So far I have heard zero complaints about this, though as Paul Ganssle pointed out on the PR they're not likely to be using the "newer" packages.

So consider me +1 for deprecate in 3.8 (we can still do that, right? it's just docs and a warning on use) and remove in 3.9 or 3.10 as appropriate.
msg347288 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-07-04 16:39
> So consider me +1 for deprecate in 3.8 (we can still do that, right? it's just docs and a warning on use) and remove in 3.9 or 3.10 as appropriate.

I modified my PR to deprecate the feature in Python 3.8. I'm not sure about scheduling the removal yet, since the Python 3.9 release schedule is under discussion:
 https://discuss.python.org/t/pep-596-python-3-9-release-schedule-doubling-the-release-cadence/1828

I would prefer to give at least 2 years to projects to update their setup.py (how they are distributed). Even if bdist_wininst has issues, it's not too painful to maintain a few more years. The removal can be decided later.
msg347312 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-07-05 08:44
New changeset 1da4462765b084dfa8d869b6cb5855e8f6014a11 by Victor Stinner in branch 'master':
bpo-37481: Deprecate distutils bdist_wininst command (GH-14553)
https://github.com/python/cpython/commit/1da4462765b084dfa8d869b6cb5855e8f6014a11
msg347317 - (view) Author: miss-islington (miss-islington) Date: 2019-07-05 09:03
New changeset b4cd6ba1a028c2624ac7bc93439b9d45f51cfeba by Miss Islington (bot) in branch '3.8':
bpo-37481: Deprecate distutils bdist_wininst command (GH-14553)
https://github.com/python/cpython/commit/b4cd6ba1a028c2624ac7bc93439b9d45f51cfeba
msg347331 - (view) Author: STINNER Victor (vstinner) * (Python committer) Date: 2019-07-05 10:26
The initial issue has been fixed. Let's continue the discussion in the Packaging forum:
https://discuss.python.org/t/deprecate-bdist-wininst/1929
History
Date User Action Args
2019-07-05 10:26:46vstinnersetstatus: open -> closed
versions: + Python 3.8
messages: + msg347331

resolution: fixed
stage: patch review -> resolved
2019-07-05 09:03:32miss-islingtonsetnosy: + miss-islington
messages: + msg347317
2019-07-05 08:44:36miss-islingtonsetpull_requests: + pull_request14412
2019-07-05 08:44:17vstinnersetmessages: + msg347312
2019-07-04 16:39:36vstinnersetmessages: + msg347288
2019-07-02 20:06:23steve.dowersetnosy: + paul.moore, tim.golden, eric.araujo, dstufft, p-ganssle, zach.ware, steve.dower
messages: + msg347153
components: + Distutils, Windows, - Library (Lib)
2019-07-02 11:19:21vstinnersetkeywords: + patch
stage: patch review
pull_requests: + pull_request14371
2019-07-02 11:06:24vstinnersettitle: Deprecate bdist_wininstr: use bdist_wheel instead -> Deprecate bdist_wininst: use bdist_wheel instead
2019-07-02 11:05:55vstinnercreate